// Code generated by go-swagger; DO NOT EDIT.

package events

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"
	"strconv"

	errors "github.com/go-openapi/errors"
	middleware "github.com/go-openapi/runtime/middleware"
	strfmt "github.com/go-openapi/strfmt"
	swag "github.com/go-openapi/swag"

	models "ticket-boss/models"
)

// SingleEventRequestHandlerFunc turns a function with the right signature into a single event request handler
type SingleEventRequestHandlerFunc func(SingleEventRequestParams, *ticketboss) middleware.Responder

// Handle executing the request and returning a response
func (fn SingleEventRequestHandlerFunc) Handle(params SingleEventRequestParams, principal *ticketboss) middleware.Responder {
	return fn(params, principal)
}

// SingleEventRequestHandler interface for that can handle valid single event request params
type SingleEventRequestHandler interface {
	Handle(SingleEventRequestParams, *ticketboss) middleware.Responder
}

// NewSingleEventRequest creates a new http.Handler for the single event request operation
func NewSingleEventRequest(ctx *middleware.Context, handler SingleEventRequestHandler) *SingleEventRequest {
	return &SingleEventRequest{Context: ctx, Handler: handler}
}

/*SingleEventRequest swagger:route GET /events/{id} Events singleEventRequest

Gets a single event details.

JSON Response is provided with respective success or fail details for event.

*/
type SingleEventRequest struct {
	Context *middleware.Context
	Handler SingleEventRequestHandler
}

func (o *SingleEventRequest) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewSingleEventRequestParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *ticketboss
	if uprinc != nil {
		principal = uprinc.(*ticketboss) // this is really a ticketboss, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// SingleEventRequestOKBody single event request o k body
// swagger:model SingleEventRequestOKBody
type SingleEventRequestOKBody struct {

	// ticket types
	TicketTypes []*models.TicketType `json:"ticket_types"`

	// event
	Event *models.Event `json:"event,omitempty"`
}

// Validate validates this single event request o k body
func (o *SingleEventRequestOKBody) Validate(formats strfmt.Registry) error {
	var res []error

	if err := o.validateTicketTypes(formats); err != nil {
		res = append(res, err)
	}

	if err := o.validateEvent(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (o *SingleEventRequestOKBody) validateTicketTypes(formats strfmt.Registry) error {

	if swag.IsZero(o.TicketTypes) { // not required
		return nil
	}

	for i := 0; i < len(o.TicketTypes); i++ {
		if swag.IsZero(o.TicketTypes[i]) { // not required
			continue
		}

		if o.TicketTypes[i] != nil {
			if err := o.TicketTypes[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("singleEventRequestOK" + "." + "ticket_types" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (o *SingleEventRequestOKBody) validateEvent(formats strfmt.Registry) error {

	if swag.IsZero(o.Event) { // not required
		return nil
	}

	if o.Event != nil {
		if err := o.Event.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("singleEventRequestOK" + "." + "event")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (o *SingleEventRequestOKBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *SingleEventRequestOKBody) UnmarshalBinary(b []byte) error {
	var res SingleEventRequestOKBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
